%global   p_vendor      pe
%global   _name         mcollective
# VERSION is subbed out during rake package:srpm process
%global   realversion   2.2.4.2
%global   rpmversion    2.2.4.2

%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%global   _with_systemd 1
%else
%global   _with_systemd 0
%endif

%if "%{_os}" == "aix"
  %{!?_aix: %global _aix 1}
%endif

# Added macros for AIX
%if 0%{?_aix}
%global   _symlinkdir   /usr/bin
%define   _sysconfdir   /etc
%define   _initrddir    %{_sysconfdir}/rc.d/init.d
%define   __patch       /opt/freeware/bin/patch
%else
%global   _symlinkdir   /usr/local/bin
%endif

%if 0%{?p_vendor:1}
    %global name_prefix      %{p_vendor}-

    # The %{!?foo: ...} idiom is needed, because the spec gets re-evaluated for
    # each package that is built.  This really messes with things that are only
    # supposed to be evaluated at "definition time".

    # Grab the "real" directories so we can reference the system's files.
    %{!?_real_initrddir:     %global _real_initrddir     %{_initrddir}}
    %{!?_real_localstatedir: %global _real_localstatedir %{_localstatedir}}
    %{!?_real_sysconfdir:    %global _real_sysconfdir    %{_sysconfdir}}

    # Use the alternate locations for things.
    %global _initrddir       %{_real_initrddir}
    %global _localstatedir   %{_real_localstatedir}
    %global _sysconfdir      %{_real_sysconfdir}/puppetlabs

    # Override the _prefix last, so we can get the _real_* locations.
    %{!?_orig_prefix:        %global _orig_prefix       %{_prefix}}
    %global                 _prefix /opt/puppet
%endif

%if 0%{?suse_version}
  %global _libexecdir      %{_prefix}/libexec
%endif

%define ruby    %{_bindir}/ruby
# Fedora 17 and later use vendorlibdir instead of sitelibdir (see https://fedoraproject.org/wiki/Packaging:Ruby?rd=Packaging/Ruby#Pure_Ruby_packages)
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%global   ruby_libdir   %(PATH=/opt/puppet/bin:$PATH; ruby -rrbconfig -e 'puts RbConfig::CONFIG["vendorlibdir"]')
%else
%global   ruby_libdir   %(PATH=/opt/puppet/bin:$PATH; ruby -rrbconfig -e "puts RbConfig::CONFIG['sitelibdir']")
%endif


Name:           %{?name_prefix}%{_name}
Version:        %{rpmversion}
Release:        1.pe%{?dist}
Summary:        Application Server for hosting Ruby code on any capable middleware
Group:          System Environment/Daemons
License:        PL Commercial
Packager:       Puppet Labs <info@puppetlabs.com>
Vendor:         Puppet Labs
URL:            http://www.puppetlabs.com/%{name}
Source0:        http://puppetlabs.com/downloads/%{name}/%{name}-%{realversion}.tar.gz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  %{?name_prefix}ruby
BuildRequires:  %{?name_prefix}ruby-stomp
%if 0%{?_aix}
BuildRequires:  sed
BuildRequires:  coreutils, binutils
%endif

Requires:       %{?name_prefix}%{_name}-common = %{version}-%{release}
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp

%if 0%{?suse_version}
BuildRequires:  procps
Requires:       procps
%endif

%if 0%{?_with_systemd}
# Required for %%post, %%preun, %%postun
Requires:       systemd
%if 0%{?fedora} >= 18
BuildRequires:  systemd
%else
BuildRequires:  systemd-units
%endif
%else
%if 0%{?suse_version}
Requires:       aaa_base
%else
# Required for %%post and %%preun
Requires:       chkconfig
# Required for %%preun and %%postun
Requires:       initscripts
%endif
%endif

Provides:       %{?name_prefix}%{_name} = %{version}-%{release}

%description
The Marionette Collective:

Server for the mcollective Application Server


%package common
Summary:        Common libraries for the mcollective clients and servers
Group:          System Environment/Libraries
Vendor:         Puppet Labs
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp
Provides:       %{?name_prefix}%{_name}-common = %{version}-%{release}

%description common
The Marionette Collective:

Common libraries for the mcollective clients and servers


%package client
Summary:        Client tools for the mcollective Application Server
Group:          Applications/System
Vendor:         Puppet Labs
Requires:       %{?name_prefix}%{_name}-common = %{version}-%{release}
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp
Provides:       %{?name_prefix}%{_name}-client = %{version}-%{release}

%description client
The Marionette Collective:

Client tools for the mcollective Application Server


%prep
%setup -q -n %{name}-%{realversion}
%if 0%{?_aix}
export PATH=/opt/puppet/bin:/opt/freeware/bin:$PATH
%endif

%build

%pre
# Stop mcollective if it's running
if /usr/bin/pgrep mcollectived >/dev/null ; then
  /sbin/service %{name} stop >/dev/null 2>&1 || :
fi
if /usr/bin/pgrep mcollectived >/dev/null ; then
  /usr/bin/pkill -9 mcollectived >/dev/null || :
  if [ -f /var/run/%{name}.pid ] ; then
  rm -f /var/run/%{name}.pid >/dev/null
  fi
fi

%install
%if 0%{?_aix}
export PATH=/opt/puppet/bin:/opt/freeware/bin:$PATH
%endif

rm -rf %{buildroot}

%{ruby} install.rb \
    --destdir=%{buildroot} \
    --no-rdoc \
    --sitelibdir=%{ruby_libdir} \
    --plugindir=%{_libexecdir}/%{_name} \
    --configdir=%{_sysconfdir}/%{_name}


%{__install} -d -m0755  %{buildroot}%{_sysconfdir}/%{_name}/plugin.d
%{__install} -d -m0755  %{buildroot}%{_sysconfdir}/%{_name}/ssl/clients
%{__install} -d -m0755  %{buildroot}/var/log/%{name}
%if 0%{?_with_systemd}
%{__install} -d -m0755  %{buildroot}%{_unitdir}
%{__install} -m0644 ext/redhat/%{name}.service %{buildroot}%{_unitdir}/
%else
%{__install} -d -m0755  %{buildroot}%{_initrddir}
%if 0%{?suse_version}
%{__install} -m0755 ext/redhat/%{name}.init.suse %{buildroot}%{_initrddir}/%{name}
%else
%{__install} -m0755 ext/redhat/%{name}.init-rh %{buildroot}%{_initrddir}/%{name}
%endif
%endif

# Modify all ruby utilities to use PE ruby
for file in `find %{buildroot} -type f`; do
    sed -i -e '1s,^#!.*ruby$,#!/opt/puppet/bin/ruby,' $file
done

# install log rotation stuff
install -d %{buildroot}/%{_real_sysconfdir}/logrotate.d
install -m644 ext/redhat/%{name}.logrotate \
    %{buildroot}/%{_real_sysconfdir}/logrotate.d/%{name}

%if 0%{?suse_version}
# sysconfig
mkdir -p  %{buildroot}%{_real_sysconfdir}/sysconfig/
install -p -m644 ext/redhat/%{name}.sysconfig %{buildroot}%{_real_sysconfdir}/sysconfig/%{name}
%endif

# rpmlint cleanups
find  %{buildroot} -name .gitignore | xargs rm -f
find  %{buildroot} -name .keep | xargs rm -f

# Link binaries to /usr/local/bin
mkdir -p %{buildroot}%{_symlinkdir}
ln -sf %{_bindir}/mco %{buildroot}%{_symlinkdir}/mco

%clean
rm -rf %{buildroot}

%post
%if 0%{?_aix}
mkssys -p %{_bindir}/ruby -s %{name} -u root -a '%{_sbindir}/mcollectived --config=%{_sysconfdir}/%{_name}/server.cfg ' -w 7 -S -n 15 -f 9 > /dev/null  2>&1 || :
%else
%if 0%{?_with_systemd}
if [ $1 -eq 1 ] ; then
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
%else
/sbin/chkconfig --add %{name} || :
%endif
%endif

%postun
%if 0%{?_with_systemd}
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart %{name}.service >/dev/null 2>&1 || :
fi
%else
if [ "$1" -ge 1 ]; then
%if 0%{?_aix}
    stopsrc -s %{name} > /dev/null 2>&1  || true
    sleep 2
    startsrc -s %{name} > /dev/null 2>&1  || true
%else
    /sbin/service %{name} condrestart &>/dev/null || :
%endif
fi
%endif

%preun
%if 0%{?_with_systemd}
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable %{name}.service > /dev/null 2>&1 || :
    /bin/systemctl stop %{name}.service > /dev/null 2>&1 || :
fi
%else
if [ "$1" = 0 ] ; then
%if 0%{?_aix}
    # Stop
    stopsrc -s %{name} > /dev/null 2>&1
    # Unregister
    rmssys -s %{name} || true
%else
    /sbin/service %{name} stop > /dev/null 2>&1
    /sbin/chkconfig --del %{name} || :
%endif
fi
%endif

%files common
%defattr(-, root, root)
%{ruby_libdir}/mcollective.rb
%{ruby_libdir}/mcollective
%{_libexecdir}/%{_name}/%{_name}/agent/*
%{_libexecdir}/%{_name}/%{_name}/audit/*
%{_libexecdir}/%{_name}/%{_name}/connector/*
%{_libexecdir}/%{_name}/%{_name}/data/*
%{_libexecdir}/%{_name}/%{_name}/facts/*
%{_libexecdir}/%{_name}/%{_name}/registration/*
%{_libexecdir}/%{_name}/%{_name}/security/*
%{_libexecdir}/%{_name}/%{_name}/validator/*
%{_libexecdir}/%{_name}/%{_name}/discovery/*
%config(noreplace)%{_sysconfdir}/%{_name}/data-help.erb
%config(noreplace)%{_sysconfdir}/%{_name}/discovery-help.erb
%config(noreplace)%{_sysconfdir}/%{_name}/metadata-help.erb

%files client
%defattr(-, root, root, 0755)
%attr(0755, root, root)%{_sbindir}/mc-call-agent
%attr(0755, root, root)%{_bindir}/mco
%{_symlinkdir}/mco
%config(noreplace)%{_sysconfdir}/%{_name}/client.cfg
%{_sysconfdir}/%{_name}/rpc-help.erb
%{_libexecdir}/%{_name}/%{_name}/application/*
%{_libexecdir}/%{_name}/%{_name}/pluginpackager/*
%{_libexecdir}/%{_name}/%{_name}/aggregate/*

%files
%defattr(-, root, root, 0755)
%attr(0755, root, root)%{_sbindir}/mcollectived
%if 0%{?_with_systemd}
%{_unitdir}/%{name}.service
%else
%{_initrddir}/%{name}
%endif
%if 0%{?suse_version}
%{_real_sysconfdir}/sysconfig/%{name}
%endif
%config(noreplace)%{_sysconfdir}/%{_name}/server.cfg
%config(noreplace)%{_sysconfdir}/%{_name}/facts.yaml
%dir %{_sysconfdir}/%{_name}/ssl/clients
%config(noreplace)%{_sysconfdir}/%{_name}/plugin.d
%dir /var/log/%{name}
%config(noreplace) %{_real_sysconfdir}/logrotate.d/%{name}

%changelog
* Wed Apr 02 2014 Puppet Labs Release <info@puppetlabs.com> -  2.2.4.2-1
- Build for 2.2.4.2

* Tue Nov 03 2009 R.I.Pienaar <rip@devco.net>
- First release
